%define		_libdir64 %{_prefix}/lib64

%{!?dotests: %define DO_TESTS 1}

Summary: Extract, test and view RAR archives
Name: unrar
Version: 6.2.12
Release: 1
License: unRAR
Group: Applications/Archiving
URL: https://www.rarlab.com/
Source0: https://www.rarlab.com/rar/unrarsrc-%{version}.tar.gz
Source1: %{name}.1
#Patch0: %{name}-%{version}-aix.patch
Patch0 : unrar.patch
Patch1 : unrar-6.2.12-makefile.patch
BuildRequires: make, libstdc++-devel >= 10.3.0 
%if %{toolchain} == "gcc"
Requires: libgcc >= 10.3.0
Requires: libstdc++ >= 10.3.0
%endif

%description
The unRAR utility is a freeware program, distributed with source code
and developed for extracting, testing and viewing the contents of
archives created with the RAR archiver version 1.50 and above.

%package -n libunrar
Summary:        Decompress library for RAR v3 archives


%description -n libunrar
The libunrar library allows programs linking against it to decompress
existing RAR v3 archives.


%package -n libunrar-devel
Summary:        Development files for libunrar
Requires:       libunrar = %{version}-%{release}

%description -n libunrar-devel
The libunrar-devel package contains libraries and header files for
developing applications that use libunrar.

%prep
%setup -q -n %{name}

# Duplicate source for 32 & 64 bits
rm -rf /tmp/%{name}-%{version}-32bit
mkdir  /tmp/%{name}-%{version}-32bit
mv *   /tmp/%{name}-%{version}-32bit
mkdir 32bit
mv     /tmp/%{name}-%{version}-32bit/* 32bit
rm -rf /tmp/%{name}-%{version}-32bit
mkdir 64bit
cp -rp 32bit/* 64bit/

%patch0 -p1
%patch1 -p1 -b .makefile
%build

cd 64bit
export CC="%{__cc__}"
export CXX="%{__cxx__}"
export OBJECT_MODE=64

export CFLAGS="-O2 -maix64"

export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib  -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib  -lbsd "

gmake %{?_smp_mflags}
gmake lib

## # now build the 32-bit version
cd ../32bit
export CC="%{__cc__}"
export CXX="%{__cxx__}"
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000 -lbsd "
export CFLAGS="-O2 -maix32 -D_LARGE_FILES " 

gmake %{?_smp_mflags}
gmake lib

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export AR="/usr/bin/ar -X64"
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
cp unrar ${RPM_BUILD_ROOT}%{_bindir}/unrar
install -Dpm 755 libunrar.so %{buildroot}%{_libdir64}/libunrar.so 
/usr/bin/ar -X64 -q %{buildroot}%{_libdir64}/libunrar.a %{buildroot}%{_libdir64}/libunrar.so
#/usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in *
  do
    mv ${f} ${f}_64
  done
)

cd ../32bit
export AR="/usr/bin/ar -X32"
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install
cp unrar ${RPM_BUILD_ROOT}%{_bindir}/unrar
install -Dpm 755 libunrar.so %{buildroot}%{_libdir}/libunrar.so
/usr/bin/ar -X32 -q %{buildroot}%{_libdir}/libunrar.a %{buildroot}%{_libdir}/libunrar.so
/usr/bin/ar -X64 -q %{buildroot}%{_libdir}/libunrar.a %{buildroot}%{_libdir64}/libunrar.so
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in $(ls -1| grep -v -e _32 -e _64)
  do
    mv ${f} ${f}_32
	ln -sf ${f}_64 ${f}
  done
)
mkdir -p -m 755 %{buildroot}/%{_includedir}/unrar/
for i in *.hpp; do
    install -Dpm 644 $i %{buildroot}/%{_includedir}/unrar/
done

#There is no inbuilt test cases
#%check
# Run testcases for 64bit
#cd 64bit
#export OBJECT_MODE=64
#export LIBPATH=${RPM_BUILD_ROOT}%{_libdir64}
#if [ "%{DO_TESTS}" == 1 ]
#then
#    (gmake -k check || true)
#fi
 
# Run testcases for 32bit
#cd ../32bit
#export OBJECT_MODE=32
#export LIBPATH=${RPM_BUILD_ROOT}%{_libdir} 
#if [ "%{DO_TESTS}" == 1 ]
#then
#    (gmake -k check || true)
#fi

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1

chmod 0755 ${RPM_BUILD_ROOT}%{_bindir}/*

cp %{SOURCE1} ${RPM_BUILD_ROOT}%{_mandir}/man1/unrar.1
chmod 0644 ${RPM_BUILD_ROOT}%{_mandir}/man1/*

# RPM Macros support
mkdir -p %{buildroot}%{_sysconfdir}/rpm
cat > %{buildroot}%{_sysconfdir}/rpm/macros.unrar << EOF
# unrar RPM Macros
%unrar_version    %{version}
EOF
touch -r license.txt %{buildroot}%{_sysconfdir}/rpm/macros.unrar

%files
%defattr(-,root,system)
%doc 32bit/acknow.txt 32bit/license.txt 32bit/readme.txt
%{_bindir}/*
%{_mandir}/man1/*

%files -n libunrar
%defattr(-,root,system) 
%{_libdir}/*.a
%{_libdir64}/*.a

%files -n libunrar-devel
%defattr(-,root,system)
%config %{_sysconfdir}/rpm/macros.unrar
%{_includedir}/unrar/

%changelog
* Fri Nov 10 2023 Harshith K A < harshith.k.a@ibm.com > - 6.2.12-1
- Updated to version 6.2.12

* Tue Apr 21 2020 Rishita Saha <risaha16@in.ibm.com>-5.9.2-1
- Updated to version 5.9.2

* Tue Sep 11 2018 Harshita Jain <harjain9@in.ibm.com>-5.6.5-1
- Updated to version 5.6.5

* Tue Aug 22 2017 Michael Perzl <michael@perzl.org> - 5.5.5-1
- updated to version 5.5.5

* Mon Dec 05 2016 Michael Perzl <michael@perzl.org> - 5.4.5-1
- updated to version 5.4.5

* Mon Dec 05 2016 Michael Perzl <michael@perzl.org> - 5.4.4-1
- updated to version 5.4.4

* Mon Dec 05 2016 Michael Perzl <michael@perzl.org> - 5.4.1-1
- updated to version 5.4.1

* Mon Dec 05 2016 Michael Perzl <michael@perzl.org> - 5.3.9-1
- updated to version 5.3.9

* Thu Jan 01 2015 Michael Perzl <michael@perzl.org> - 5.3.8-1
- updated to version 5.3.8

* Tue Dec 09 2014 Michael Perzl <michael@perzl.org> - 5.2.2-1
- updated to version 5.2.2

* Tue Dec 09 2014 Michael Perzl <michael@perzl.org> - 5.0.12-1
- updated to version 5.0.12

* Tue Dec 09 2014 Michael Perzl <michael@perzl.org> - 5.0.3-1
- updated to version 5.0.3

* Tue Jun 19 2012 Michael Perzl <michael@perzl.org> - 4.2.4-1
- updated to version 4.2.4

* Fri Jul 01 2011 Michael Perzl <michael@perzl.org> - 4.0.7-1
- updated to version 4.0.7

* Wed Jan 12 2011 Michael Perzl <michael@perzl.org> - 4.0.4-1
- updated to version 4.0.4

* Mon May 26 2008 Michael Perzl <michael@perzl.org> - 3.7.8-1
- first version for AIX V5.1 and higher
